// autogenerated by syzkaller (http://github.com/google/syzkaller)

#define _GNU_SOURCE

#include <endian.h>
#include <errno.h>
#include <linux/futex.h>
#include <pthread.h>
#include <signal.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/prctl.h>
#include <sys/syscall.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <time.h>
#include <unistd.h>

__attribute__((noreturn)) static void doexit(int status)
{
  volatile unsigned i;
  syscall(__NR_exit_group, status);
  for (i = 0;; i++) {
  }
}

#include <stdint.h>
#include <string.h>

const int kFailStatus = 67;
const int kRetryStatus = 69;

static void fail(const char* msg, ...)
{
  int e = errno;
  va_list args;
  va_start(args, msg);
  vfprintf(stderr, msg, args);
  va_end(args);
  fprintf(stderr, " (errno %d)\n", e);
  doexit((e == ENOMEM || e == EAGAIN) ? kRetryStatus : kFailStatus);
}

static uint64_t current_time_ms()
{
  struct timespec ts;

  if (clock_gettime(CLOCK_MONOTONIC, &ts))
    fail("clock_gettime failed");
  return (uint64_t)ts.tv_sec * 1000 + (uint64_t)ts.tv_nsec / 1000000;
}

static void test();

void loop()
{
  int iter;
  for (iter = 0;; iter++) {
    int pid = fork();
    if (pid < 0)
      fail("loop fork failed");
    if (pid == 0) {
      prctl(PR_SET_PDEATHSIG, SIGKILL, 0, 0, 0);
      setpgrp();
      test();
      doexit(0);
    }
    int status = 0;
    uint64_t start = current_time_ms();
    for (;;) {
      int res = waitpid(-1, &status, __WALL | WNOHANG);
      if (res == pid)
        break;
      usleep(1000);
      if (current_time_ms() - start > 5 * 1000) {
        kill(-pid, SIGKILL);
        kill(pid, SIGKILL);
        while (waitpid(-1, &status, __WALL) != pid) {
        }
        break;
      }
    }
  }
}

struct thread_t {
  int created, running, call;
  pthread_t th;
};

static struct thread_t threads[16];
static void execute_call(int call);
static int running;

static void* thr(void* arg)
{
  struct thread_t* th = (struct thread_t*)arg;
  for (;;) {
    while (!__atomic_load_n(&th->running, __ATOMIC_ACQUIRE))
      syscall(SYS_futex, &th->running, FUTEX_WAIT, 0, 0);
    execute_call(th->call);
    __atomic_fetch_sub(&running, 1, __ATOMIC_RELAXED);
    __atomic_store_n(&th->running, 0, __ATOMIC_RELEASE);
    syscall(SYS_futex, &th->running, FUTEX_WAKE);
  }
  return 0;
}

static void execute(int num_calls)
{
  int call, thread;
  running = 0;
  for (call = 0; call < num_calls; call++) {
    for (thread = 0; thread < sizeof(threads) / sizeof(threads[0]);
         thread++) {
      struct thread_t* th = &threads[thread];
      if (!th->created) {
        th->created = 1;
        pthread_attr_t attr;
        pthread_attr_init(&attr);
        pthread_attr_setstacksize(&attr, 128 << 10);
        pthread_create(&th->th, &attr, thr, th);
      }
      if (!__atomic_load_n(&th->running, __ATOMIC_ACQUIRE)) {
        th->call = call;
        __atomic_fetch_add(&running, 1, __ATOMIC_RELAXED);
        __atomic_store_n(&th->running, 1, __ATOMIC_RELEASE);
        syscall(SYS_futex, &th->running, FUTEX_WAKE);
        struct timespec ts;
        ts.tv_sec = 0;
        ts.tv_nsec = 20 * 1000 * 1000;
        syscall(SYS_futex, &th->running, FUTEX_WAIT, 1, &ts);
        if (running)
          usleep((call == num_calls - 1) ? 10000 : 1000);
        break;
      }
    }
  }
}

long r[3];
uint64_t procid;
void execute_call(int call)
{
  switch (call) {
  case 0:
    syscall(__NR_mmap, 0x20000000, 0xfff000, 0x3, 0x32, 0xffffffff,
            0x0);
    break;
  case 1:
    r[0] = syscall(__NR_socket, 0x2, 0x80001, 0x0);
    break;
  case 2:
    memcpy((void*)0x2003b000, "\x6c\x6f\x00\x00\x00\x00\x00\x00\x00\x00"
                              "\x00\x00\x00\x00\x00\x00",
           16);
    *(uint16_t*)0x2003b010 = 0xfffd;
    syscall(__NR_ioctl, r[0], 0x8914, 0x2003b000);
    break;
  case 3:
    r[1] = syscall(__NR_socket, 0xa, 0x6, 0x0);
    break;
  case 4:
    *(uint16_t*)0x20000000 = 0xa;
    *(uint16_t*)0x20000002 = htobe16(0x4e23 + procid * 0x4ul);
    *(uint32_t*)0x20000004 = 0x0;
    *(uint8_t*)0x20000008 = 0x0;
    *(uint8_t*)0x20000009 = 0x0;
    *(uint8_t*)0x2000000a = 0x0;
    *(uint8_t*)0x2000000b = 0x0;
    *(uint8_t*)0x2000000c = 0x0;
    *(uint8_t*)0x2000000d = 0x0;
    *(uint8_t*)0x2000000e = 0x0;
    *(uint8_t*)0x2000000f = 0x0;
    *(uint8_t*)0x20000010 = 0x0;
    *(uint8_t*)0x20000011 = 0x0;
    *(uint8_t*)0x20000012 = 0x0;
    *(uint8_t*)0x20000013 = 0x0;
    *(uint8_t*)0x20000014 = 0x0;
    *(uint8_t*)0x20000015 = 0x0;
    *(uint8_t*)0x20000016 = 0x0;
    *(uint8_t*)0x20000017 = 0x0;
    *(uint32_t*)0x20000018 = 0x0;
    syscall(__NR_bind, r[1], 0x20000000, 0x1c);
    break;
  case 5:
    syscall(__NR_listen, r[1], 0x8000);
    break;
  case 6:
    r[2] = syscall(__NR_socket, 0x2, 0x6, 0x0);
    break;
  case 7:
    *(uint8_t*)0x2030a000 = 0xfe;
    *(uint8_t*)0x2030a001 = 0x80;
    *(uint8_t*)0x2030a002 = 0x0;
    *(uint8_t*)0x2030a003 = 0x0;
    *(uint8_t*)0x2030a004 = 0x0;
    *(uint8_t*)0x2030a005 = 0x0;
    *(uint8_t*)0x2030a006 = 0x0;
    *(uint8_t*)0x2030a007 = 0x0;
    *(uint8_t*)0x2030a008 = 0x0;
    *(uint8_t*)0x2030a009 = 0x0;
    *(uint8_t*)0x2030a00a = 0x0;
    *(uint8_t*)0x2030a00b = 0x0;
    *(uint8_t*)0x2030a00c = 0x0;
    *(uint8_t*)0x2030a00d = 0x0;
    *(uint8_t*)0x2030a00e = 0x0 + procid * 0x1ul;
    *(uint8_t*)0x2030a00f = 0xaa;
    *(uint32_t*)0x2030a010 = 0x1ff;
    *(uint8_t*)0x2030a014 = 0x0;
    *(uint8_t*)0x2030a015 = 0x3;
    *(uint16_t*)0x2030a016 = 0x4;
    *(uint16_t*)0x2030a018 = 0x3;
    *(uint16_t*)0x2030a01a = 0x1;
    *(uint32_t*)0x2030a01c = 0x2;
    syscall(__NR_setsockopt, r[1], 0x29, 0x20, 0x2030a000, 0x20);
    break;
  case 8:
    *(uint16_t*)0x20772000 = 0x2;
    *(uint16_t*)0x20772002 = htobe16(0x4e23 + procid * 0x4ul);
    *(uint32_t*)0x20772004 = htobe32(0x0);
    *(uint8_t*)0x20772008 = 0x0;
    *(uint8_t*)0x20772009 = 0x0;
    *(uint8_t*)0x2077200a = 0x0;
    *(uint8_t*)0x2077200b = 0x0;
    *(uint8_t*)0x2077200c = 0x0;
    *(uint8_t*)0x2077200d = 0x0;
    *(uint8_t*)0x2077200e = 0x0;
    *(uint8_t*)0x2077200f = 0x0;
    syscall(__NR_connect, r[2], 0x20772000, 0x10);
    break;
  }
}

void test()
{
  memset(r, -1, sizeof(r));
  execute(9);
}

int main()
{
  int i;
  for (i = 0; i < 8; i++) {
    if (fork() == 0) {
      procid = i;
      loop();
      return 0;
    }
  }
  sleep(1000000);
  return 0;
}
